Zielgruppe:  
* Kassenärztliche Vereinigungen, Auswertungsstelle  
* Leistungserbinger selbst können das XSL-Skript nicht ausführen, da die gängigen Web-Broswer XSL in ihrer Standardeinstellung nicht unterstützten. Das Datenflussprotokoll ist in XML lesbar. Besser ist aber der Import in eine PB-Software. Spezifikationskonforme PB-Software-Produkte ermöglichen eine direkte Verknüpfung der Validierungsergebnisse mit den jeweiligen dokumentierten Vorgängen.  


Allgemeine Hinweise  
* Kodierung: UTF-8  
* Die Datenflussprotokolle müssen gegen das XML-Schema interface_BAS/response_BAS_DAS.xsd valide sein. (Miniprotokolle sind valide mit interface_BAS/response_BAS_DAS.xsd. Für sie wird ebenfalls eine HTML-Ansicht erzeugt.)  
* Standardansicht:  
  * Alle validation_items mit ERROR sind aufgeklappt.  
  * Da die HTML-Ansicht auch als Druckvorlage genutzt wird, sind alle validation_items mit WARNING ebenfalls aufgeklappt.  
  * "OK" ist zugeklappt.  
* wenn ein ERROR vorliegt und das DFP kein Miniprotokoll ist, dann gilt:  
  * validation_provider sind sortiert (ERROR oben)  
  * validation_items sind sortiert (ERROR oben)  
  * Hinweistext:  
      Prüfergebnis ERROR: Auffälligkeiten bzw. Fehler, die eine Weiterverarbeitung ausschließen. Eine Korrektur und erneute Lieferung sind erforderlich. Die Anzahl der abgelehnten Datensätze kann der Spalte corrupted entnommen werden. // Prüfergebnis WARNING: Auffälligkeiten, die einer Weiterverarbeitung nicht im Weg stehen // Prüfergebnis OK: Keine Auffälligkeiten  
* zusätzlicher Hinweis bei Miniprotokollen:  
  * 'Kein Datensatz aus dieser Exportdatei konnte aufgrund des genannten Fehlers weiter verarbeitet werden. Diese fehlerhaften Datensätze müssen korrigiert und erneut versendet werden.'  
* Fehlermeldung, wenn die Inputdatei kein Datenflussprotokoll ist:  
  * 'Die Eingabedatei ist kein Datenflussprotokoll. Das XML-Element validation_provider fehlt.'  
* Unterschiede zwischen XML-Datenflussprotokoll (XML-DFP) und HTML-Ansicht:  
  * Wenn status_document == "ERROR", dann entsprechen die Werte in "gesamt" und "corrupted" in der Tabelle "Verarbeitete Datensätze je Datencontainer" jeweils der Anzahl der Fälle.  
    * Hintergrund: Wenn keine Fehler auf Dokumentenebene (QSDOK.vPruefung.[protokoll-Level] = "DK" bzw. /root/header/protocol/validation_provider/validation_item/status/error) im vollständigen XML-DFP vorliegen, dann entspricht die Tabelle "Verarbeitete Datensätze je Datencontainer" jeweils den Werten aus //statistic/processed. Liegen allerdings Fehler auf Dokumentenebene mit rule_type/@V="H" vor, sind die Werte in den statistic/processed-Blöcken zu ignorieren. Es gilt:  Wenn status_document = "ERROR", dann wird kein Datensatz aus der Exportdatei im Echtdatenpool berücksichtigt.  
  * status_document wird nicht mehr angezeigt  
    * Hintergrund: status_document wird nicht mehr angezeigt, da ein WARNING in status_document nicht differenziert zwischen WARNING und ERROR auf Datensatzebene. Laut technischer Dokumentation ist status_document erst dann ERROR, wenn alle Datensätze einen ERROR enthalten oder (logisches oder) ein ERROR auf Dokumentenebene vorliegt. (Hinweis: status_document fehlt nur in der HTML Ansicht und nicht im DFP-XML.)  
  * Wenn ERROR auf Datensatzebene, dann wird der zugehörige /root/header/protocol/validation_provider/validation_item/status in der HTML-Ansicht auf ERROR gesetzt. Dem Leistungserbringer wird nur dann ein WARNING angezeigt, wenn status/@V in allen validation_items mit derselben validation_item/@id ungleich ERROR ist.  
  * Bei Fehlern auf Dokumentenebene wird aus Gründen der besseren Verständlichkeit statt "H" bzw. "W" ein "ERROR" bzw. "WARNING" angezeigt.  
